webpackJsonp([75],{103:function(n,t){n.exports='## Top App Bar\n\nTop App Bar acts as a container for items such as application title, navigation icon, and action items.\n\n## Usage\n\nMethod1:\n\n```html\n<m-top-app-bar adjust dense fixed\n  heading=\'Omim\'\n  navigations="[\'favorite\']"\n  action-items="[{text: \'Omim\'}, \'favorite_border\', \'favorite_border\']"\n></m-top-app-bar>\n```\n\nMethod2 (the navigation button customizes any element):\n\n```html\n<m-top-app-bar\n  heading=\'Click to view all menus\'\n  adjust>\n  <navigation>\n    <m-avatar icon="person" background-color=\'#FFF\' color=\'#0072d9\' />\n  </navigation>\n  <actionitem>\n    <m-badge css="..." content="99">\n      <m-icon path="..." color="#FFF" />\n    </m-badge>\n  </actionitem>\n  <div style=\'width:100%\'>\n    <m-tab css={`.mdc-tab-bar {background: #EEE;}`} default-active=\'speed\' align="end" stacked>\n      <item label="Recents" value="speed" icon="access_time"></item>\n      <item label="Nearby" value="fire" icon="near_me"></item>\n      <item label="Favorites" value="lol" icon="favorite"></item>\n    </m-tab>\n  </div>\n</m-top-app-bar>\n```\n\n## Usage in Omi\n\nJSX:\n\nMethod1:\n\n```jsx\n<m-top-app-bar adjust dense fixed\n  heading=\'Omim\'\n  navigations={[\'favorite\']}\n  action-items={[{text: \'Omim\'}, \'favorite_border\', \'favorite_border\']}\n  onNavigation={this.onMenu}\n  onAction={this.onMenu}\n/>\n```\n\nMethod2 (the navigation button customizes any element):\n\n```jsx\n<m-top-app-bar\n  heading={\'Click to show menus\' + this.titleOmi}\n  scroll-target={this.scrollTarget}\n  onNavigation={this.onDemoStart}\n  onAction={this.onMenuStart}>\n  <navigation>\n    <m-avatar icon="person" backgroundColor=\'#FFF\' color={this.themeColor} />\n  </navigation>\n  <actionitem>\n    <m-badge css={`...`} content="99">\n      <m-icon path="..." color="#FFF" />\n    </m-badge>\n  </actionitem>\n</m-top-app-bar>\n```\n\n## API\n\n### Props\n\n|  **Name**  | **Type**        | **Defaults**  | **Details**  |\n| ------------- |:-------------:|:-----:|:-------------:|\n| heading | string | -- | title content |\n| short | boolean | -- | With shortened animation |\n| shortCollapsed | boolean | -- | Fixed to a shortened state |\n| prominent | boolean | -- | Highlight title |\n| dense | boolean | -- | More compact top app bar |\n| fixed | boolean | -- | Fixation top app bar |\n| adjust | boolean | -- | Automatically fills the top app bar height |\n| bottom | boolean | -- | Bottom application bar |\n| navigations | object | -- | Left navigation button |\n| actionItems | object | -- | Right button |\n| scrollTarget | EventTarget | window | Set the target scrollbar (used by JSX) |\n| scrollTargetId | string | window | Set the target scrollbar (used by native js) |\n| onNavigation | function | -- | Click on the left navigation bar to trigger |\n| onAction | function | -- | Click the button on the right to trigger |\n'}});
//# sourceMappingURL=75.ebf9a8b3.chunk.js.map